(function() {
    IntelliServe_Dxtreme.AddressViewModel = function(data) {
            this.Oid = ko.observable();
            this.Street = ko.observable();
            this.City = ko.observable();
            this.StateProvince = ko.observable();
            this.ZipPostal = ko.observable();
            this.Country1 = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.AddressViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Street: this.Street(),
                City: this.City(),
                StateProvince: this.StateProvince(),
                ZipPostal: this.ZipPostal(),
                Country1: IntelliServe_Dxtreme.db.objectLink("Countries", this.Country1() ? this.Country1().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Street(data.Street);
                this.City(data.City);
                this.StateProvince(data.StateProvince);
                this.ZipPostal(data.ZipPostal);
                if(data.Country1)
                    this.Country1(new IntelliServe_Dxtreme.CountryViewModel(data.Country1));
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Street(undefined);
            this.City(undefined);
            this.StateProvince(undefined);
            this.ZipPostal(undefined);
            this.Country1(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();