(function() {
    IntelliServe_Dxtreme.CalendarEventBasViewModel = function(data) {
            this.Event = ko.observable();
            this.Oid = ko.observable();
            this.EventEntryBase1 = ko.observable();
            this.UserBase = ko.observable();
            this.EmployeeBase = ko.observable();
            this.TeamBase = ko.observable();
            this.AssignedTeamEmployees = ko.observable();
            this.CalenderSyncProcessed = ko.observable();
            this.ProcessCalenderSync = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.CalendarEventBasViewModel.prototype, {
        toJS: function() {
            return {
                Event: IntelliServe_Dxtreme.db.objectLink("Events", this.Event() ? this.Event().Oid(): undefined),
                Oid: this.Oid(),
                EventEntryBase1: IntelliServe_Dxtreme.db.objectLink("EventEntryBases", this.EventEntryBase1() ? this.EventEntryBase1().Oid(): undefined),
                UserBase: IntelliServe_Dxtreme.db.objectLink("UserBases", this.UserBase() ? this.UserBase().Oid(): undefined),
                EmployeeBase: IntelliServe_Dxtreme.db.objectLink("EmployeeBases", this.EmployeeBase() ? this.EmployeeBase().Oid(): undefined),
                TeamBase: IntelliServe_Dxtreme.db.objectLink("TeamBases", this.TeamBase() ? this.TeamBase().Oid(): undefined),
                AssignedTeamEmployees: this.AssignedTeamEmployees(),
                CalenderSyncProcessed: this.CalenderSyncProcessed(),
                ProcessCalenderSync: this.ProcessCalenderSync(),
            };
        },

        fromJS: function(data) {
            if(data) {
                if(data.Event)
                    this.Event(new IntelliServe_Dxtreme.EventViewModel(data.Event));
                this.Oid(data.Oid);
                if(data.EventEntryBase1)
                    this.EventEntryBase1(new IntelliServe_Dxtreme.EventEntryBasViewModel(data.EventEntryBase1));
                if(data.UserBase)
                    this.UserBase(new IntelliServe_Dxtreme.UserBasViewModel(data.UserBase));
                if(data.EmployeeBase)
                    this.EmployeeBase(new IntelliServe_Dxtreme.EmployeeBasViewModel(data.EmployeeBase));
                if(data.TeamBase)
                    this.TeamBase(new IntelliServe_Dxtreme.TeamBasViewModel(data.TeamBase));
                this.AssignedTeamEmployees(data.AssignedTeamEmployees);
                this.CalenderSyncProcessed(data.CalenderSyncProcessed);
                this.ProcessCalenderSync(data.ProcessCalenderSync);
            }
        },

        clear: function() {
            this.Event(undefined);
            this.Oid(undefined);
            this.EventEntryBase1(undefined);
            this.UserBase(undefined);
            this.EmployeeBase(undefined);
            this.TeamBase(undefined);
            this.AssignedTeamEmployees(undefined);
            this.CalenderSyncProcessed(undefined);
            this.ProcessCalenderSync(undefined);
        }
    });
})();