(function() {
    IntelliServe_Dxtreme.ConsignmentBasViewModel = function(data) {
            this.Oid = ko.observable();
            this.Person = ko.observable();
            this.ConsignmentNumber = ko.observable();
            this.Priority = ko.observable();
            this.CustomStatu = ko.observable();
            this.DescriptionOfGoods = ko.observable();
            this.ReferenceNo = ko.observable();
            this.DateToCollect = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.XPObjectType = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ConsignmentBasViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Person: IntelliServe_Dxtreme.db.objectLink("People", this.Person() ? this.Person().Oid(): undefined),
                ConsignmentNumber: this.ConsignmentNumber(),
                Priority: this.Priority(),
                CustomStatu: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu() ? this.CustomStatu().Oid(): undefined),
                DescriptionOfGoods: this.DescriptionOfGoods(),
                ReferenceNo: this.ReferenceNo(),
                DateToCollect: this.DateToCollect(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                XPObjectType: IntelliServe_Dxtreme.db.objectLink("XPObjectTypes", this.XPObjectType() ? this.XPObjectType().OID(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Person)
                    this.Person(new IntelliServe_Dxtreme.PersonViewModel(data.Person));
                this.ConsignmentNumber(data.ConsignmentNumber);
                this.Priority(data.Priority);
                if(data.CustomStatu)
                    this.CustomStatu(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu));
                this.DescriptionOfGoods(data.DescriptionOfGoods);
                this.ReferenceNo(data.ReferenceNo);
                this.DateToCollect(data.DateToCollect);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                if(data.XPObjectType)
                    this.XPObjectType(new IntelliServe_Dxtreme.XPObjectTypeViewModel(data.XPObjectType));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Person(undefined);
            this.ConsignmentNumber(undefined);
            this.Priority(undefined);
            this.CustomStatu(undefined);
            this.DescriptionOfGoods(undefined);
            this.ReferenceNo(undefined);
            this.DateToCollect(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.XPObjectType(undefined);
        }
    });
})();