(function() {
    IntelliServe_Dxtreme.CreditNoteViewModel = function(data) {
            this.Oid = ko.observable();
            this.CreditNoteNumber = ko.observable();
            this.User1 = ko.observable();
            this.Client1 = ko.observable();
            this.DateOfIssue = ko.observable();
            this.Terms = ko.observable();
            this.Notes = ko.observable();
            this.VatPercentage = ko.observable();
            this.Transaction1 = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.Invoice1 = ko.observable();
            this.VATExempt = ko.observable();
            this.AdditionalPercentage = ko.observable();
            this.GCRecord = ko.observable();
            this.DiscountPercent = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.CreditNoteViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                CreditNoteNumber: this.CreditNoteNumber(),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                DateOfIssue: this.DateOfIssue(),
                Terms: this.Terms(),
                Notes: this.Notes(),
                VatPercentage: this.VatPercentage(),
                Transaction1: IntelliServe_Dxtreme.db.objectLink("Transactions", this.Transaction1() ? this.Transaction1().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                VATExempt: this.VATExempt(),
                AdditionalPercentage: this.AdditionalPercentage(),
                GCRecord: this.GCRecord(),
                DiscountPercent: this.DiscountPercent(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.CreditNoteNumber(data.CreditNoteNumber);
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                this.DateOfIssue(data.DateOfIssue);
                this.Terms(data.Terms);
                this.Notes(data.Notes);
                this.VatPercentage(data.VatPercentage);
                if(data.Transaction1)
                    this.Transaction1(new IntelliServe_Dxtreme.TransactionViewModel(data.Transaction1));
                this.OptimisticLockField(data.OptimisticLockField);
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                this.VATExempt(data.VATExempt);
                this.AdditionalPercentage(data.AdditionalPercentage);
                this.GCRecord(data.GCRecord);
                this.DiscountPercent(data.DiscountPercent);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.CreditNoteNumber(undefined);
            this.User1(undefined);
            this.Client1(undefined);
            this.DateOfIssue(undefined);
            this.Terms(undefined);
            this.Notes(undefined);
            this.VatPercentage(undefined);
            this.Transaction1(undefined);
            this.OptimisticLockField(undefined);
            this.Invoice1(undefined);
            this.VATExempt(undefined);
            this.AdditionalPercentage(undefined);
            this.GCRecord(undefined);
            this.DiscountPercent(undefined);
        }
    });
})();