﻿(function () {
    var dbUtils = (function () {
        var pgetDateTime = function () {
            var now = new Date();
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            var hour = now.getHours();
            var minute = now.getMinutes();
            var second = now.getSeconds();

            if (month.toString().length === 1) {
                month = '0' + month;
            }
            if (day.toString().length === 1) {
                day = '0' + day;
            }
            if (hour.toString().length === 1) {
                hour = '0' + hour;
            }
            if (minute.toString().length === 1) {
                minute = '0' + minute;
            }
            if (second.toString().length === 1) {
                second = '0' + second;
            }
            var dateTime = year + '/' + month + '/' + day + ' ' + hour + ':' + minute + ':' + second;

            return dateTime;
        };
        return {
            getDateTime: function () {
                pgetDateTime();
            }
        }
    })();

    function guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
              .toString(16)
              .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
          s4() + '-' + s4() + s4() + s4();
    }

    IntelliServe_Dxtreme.dbDataLayer = function () {
        var _instance;
        var endpointSelector = new DevExpress.EndpointSelector(IntelliServe_Dxtreme.config.endpoints);
        var dataManipulation = DataManipulationRight(endpointSelector.urlFor("db"));

        function CreateDataLayer() {
            var pGetJobcardDetails = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.v_Jobcards_Mobile,
                    sort: [{ selector: "BookedTime", desc: true }],
                    filter: ([["TeamMembers", "contains", IntelliServe_Dxtreme.currentUser.UserName()], "and", ["IsCompleted", "=", false]]),
                    searchExpr: ["StatusDescription", "Client","JobCardNumber", "FullAddress", "ReferenceNumber", "PolicyNumber","Notes","TeamMembers"],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.v_Jobcards_MobileViewModel(item);
                    }
                });
            };

            var pGetJobcardDetailsClosed = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.v_Jobcards_Mobile,
                    sort: [{ selector: "BookedTime", desc: true }],
                    filter: ([["TeamMembers", "contains", IntelliServe_Dxtreme.currentUser.UserName()], "and", ["IsCompleted", "=", true]]),
                    searchExpr: ["StatusDescription", "Client", "JobCardNumber", "FullAddress", "ReferenceNumber", "PolicyNumber", "Notes", "TeamMembers"],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.v_Jobcards_MobileViewModel(item);
                    }
                });
            };

            var pGetClientContacts = function (clientid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.ClientContacts,
                    filter: [['Client1.Oid', new DevExpress.data.EdmLiteral("guid'" + clientid + "'")], "and", ["GCRecord", "=", null]],
                    sort: [{ selector: "LastName", desc: false }],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.ClientContactViewModel(item);
                    }
                });
            };

            var pGetJobcardItems = function (jobcardid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.JobCardItems,
                    filter: [['JobCard1.Oid', new DevExpress.data.EdmLiteral("guid'" + jobcardid + "'")], "and", ["GCRecord", "=", null]],
                    sort: [{ selector: "Description", desc: false }],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.JobCardItemViewModel(item);
                    }
                });
            };

            var pGetJobcardEquipments = function (jobcardid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.JobCardEquipments,
                    expand: ["Equipment1", "Equipment1.EquipmentType1"],
                    filter: [['JobCard1.Oid', new DevExpress.data.EdmLiteral("guid'" + jobcardid + "'")], "and", ["GCRecord", "=", null]],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.JobCardEquipmentViewModel(item);
                    }
                });
            };

            var pGetJobcardCheckList = function (jobcardid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.JobCardChecklists,
                    expand: ["CustomStatu"],
                    filter: [['JobCard1.Oid', new DevExpress.data.EdmLiteral("guid'" + jobcardid + "'")], "and", ["GCRecord", "=", null]],
                    sort: [{ selector: "Description", desc: false }],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.JobCardChecklistViewModel(item);
                    }
                });
            };

            var pGetCheckLists = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.Checklists,
                    filter: [["GCRecord", "=", null]],
                    sort: [{ selector: "Description", desc: false }],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.ChecklistViewModel(item);
                    }
                });
            };

            var pGetCheckListItems = function (checklistid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.ChecklistItems,
                    expand: ["CheckListGroup1"],
                    filter: [['Checklist1.Oid', new DevExpress.data.EdmLiteral("guid'" + checklistid + "'")], "and", ["GCRecord", "=", null]],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.ChecklistItemViewModel(item);
                    }
                });
            };

            var pGetJobcardAttachments = function (jobcardid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.v_JobCardAttachment_Mobile,
                    filter: [['JobCard', new DevExpress.data.EdmLiteral("guid'" + jobcardid + "'")], "and", ["GCRecord", "=", null]],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.v_JobCardAttachment_MobileViewModel(item);
                    }
                });
            };

            var pGetJobcardCheckListItems = function (checklistid) {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.v_JobCardChecklistItems_Mobile,
                    filter: ['JobCardChecklistOid', new DevExpress.data.EdmLiteral("guid'" + checklistid + "'")],
                    group: "GroupName",
                    sort: [{ selector: "Order", desc: false }],
                    map: function (item) {
                        return new IntelliServe_Dxtreme.v_JobCardChecklistItems_MobileViewModel(item);
                    }
                });
            };

            var pJobTypeDetails = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.JobTypes,
                    sort: [{ selector: "Type", desc: false }],
                    filter: ([["GCRecord", "=", null]]),
                    map: function (item) {
                        return new IntelliServe_Dxtreme.JobTypeViewModel(item);
                    }
                });
            };

            var pClientDetails = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.v_Clients_Mobile,
                    sort: [{ selector: "FullName", desc: false }],
                    filter: ([["GCRecord", "=", null]]),
                    map: function (item) {
                        return new IntelliServe_Dxtreme.v_Clients_MobileViewModel(item);
                    }
                });
            };

            var pLocationDetails = function (Client) {
                if (Client == null) {
                    return new DevExpress.data.DataSource({
                        store: IntelliServe_Dxtreme.db.v_Locations_Mobile,
                        sort: [{ selector: "FullAddress", desc: false }],
                        filter: (["GCRecord", "=", null]),
                        map: function (item) {
                            return new IntelliServe_Dxtreme.v_Locations_MobileViewModel(item);
                        }
                    });
                } else {
                    return new DevExpress.data.DataSource({
                        store: IntelliServe_Dxtreme.db.v_Locations_Mobile,
                        sort: [{ selector: "FullAddress", desc: false }],
                        filter: ([["GCRecord", "=", null], "and", ["Client", "=", Client]]),
                        map: function (item) {
                            return new IntelliServe_Dxtreme.v_Locations_MobileViewModel(item);
                        }
                    });
                }
            };

            var pItemDetails = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.Items,
                    sort: [{ selector: "Description", desc: false }],
                    filter: ([["GCRecord", "=", null]]),
                    map: function (item) {
                        return new IntelliServe_Dxtreme.ItemViewModel(item);
                    }
                });
            };

            var pCustomStatus = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.CustomStatus,
                    sort: [{ selector: "Status", desc: false }],
                    filter: ([["GCRecord", "=", null]]),
                    map: function (item) {
                        return new IntelliServe_Dxtreme.CustomStatuViewModel(item);
                    }
                });
            };

            var pDefaultStatus = function () {
                return new DevExpress.data.DataSource({
                    store: IntelliServe_Dxtreme.db.CustomStatus,
                    filter: ([["IsDefault", "=", true], "and", ["GCRecord", "=", null]]),
                    pageSize: 1,
                    map: function (item) {
                        return new IntelliServe_Dxtreme.CustomStatuViewModel(item);
                    }
                });
            };

            var pIsUserAllowed = function (CallbackMethod) {
                dataManipulation.IsUserAllowed(CallbackMethod);
            };

            var pGetDatabases = function (CallbackMethod) {
                dataManipulation.GetDatabases(CallbackMethod);
            };

            var pInsertJobCardCheckList = function (jobcardid, CheckList) {
                var item = new IntelliServe_Dxtreme.JobCardChecklistViewModel(),
                    items = pGetCheckListItems(CheckList.Oid()), data, defaultStatus = pDefaultStatus();

                item.Oid = ko.observable(guid());
                item.Description = ko.observable(CheckList.Description());
                item.Checklist1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Checklists', CheckList.Oid()));
                item.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                defaultStatus.load().done(function (result) {
                    var array = result;

                    for (var i = 0; i < array.length; i++) {
                        item.CustomStatu = ko.observable(IntelliServe_Dxtreme.db.objectLink('CustomStatus', result[i].Oid()));
                    }
                });

                data = IntelliServe_Dxtreme.db.JobCardChecklists.insert(item.toJS());

                items.load().done(function (result) {
                    var array = result;

                    for (var i = 0; i < array.length; i++) {
                        pInsertJobCardCheckListItem(item.Oid(), result[i]);
                    }

                });

                return data;
            };

            var pInsertJobCardCheckListItem = function (jobcardchecklistid, CheckListItem) {
                var item = new IntelliServe_Dxtreme.JobCardChecklistItemViewModel();

                item.Oid = ko.observable(guid());
                item.Order = ko.observable(CheckListItem.Order());
                item.Label = ko.observable(CheckListItem.Label());
                item.Units = ko.observable(CheckListItem.Units());
                item.DataType = ko.observable(CheckListItem.DataType());
                item.JobCardChecklist1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCardChecklists', jobcardchecklistid));

                if (CheckListItem.CheckListGroup1() != null) {
                    item.CheckListGroup1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('CheckListGroups', CheckListItem.CheckListGroup1().Oid()));
                }

                return IntelliServe_Dxtreme.db.JobCardChecklistItems.insert(item.toJSNew());
            };

            var pInsertJobCardImage = function (jobcardid, imageData) {
                var image = new IntelliServe_Dxtreme.JobCardImageViewModel();

                image.Oid = ko.observable(guid());
                image.Description = ko.observable(guid());
                image.Image = ko.observable(imageData);
                image.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                return IntelliServe_Dxtreme.db.JobCardImages.insert(image.toJS());
            };

            var pInsertJobCardTimeLog = function (Jobcardid, StartODOReading) {
                var timeLog = new IntelliServe_Dxtreme.JobCardTimeLogViewModel();

                timeLog.Oid = ko.observable(guid());
                timeLog.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', Jobcardid));
                timeLog.BookedTime = ko.observable(new Date());
                timeLog.StartDate = ko.observable(new Date());
                timeLog.StartODOReading = ko.observable(StartODOReading == "" ? 0 : StartODOReading);

                return IntelliServe_Dxtreme.db.JobCardTimeLogs.insert(timeLog.toJS());
            };

            var pUpdateJobCardTimeLog = function (oid, EndODOReading) {
                var timeLog = new IntelliServe_Dxtreme.JobCardTimeLogViewModel();

                timeLog.Oid = ko.observable(oid);
                timeLog.EndDate = ko.observable(new Date());
                timeLog.EndODOReading = ko.observable(EndODOReading == "" ? 0 : EndODOReading);

                return IntelliServe_Dxtreme.db.JobCardTimeLogs.update(oid, timeLog.toJS());
            };

            var pInsertJobCardSignature = function (jobcardid, imageData, latitude, longitude) {
                var image = new IntelliServe_Dxtreme.JobCardSignatureViewModel();

                image.Oid = ko.observable(guid());
                image.Latitude = ko.observable(latitude);
                image.Longitude = ko.observable(longitude);
                image.Image = ko.observable(imageData.replace("data:image/png;base64,", ""));
                image.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                return IntelliServe_Dxtreme.db.JobCardSignatures.insert(image.toJS());
            };

            var pInsertTeamLocation = function (Latitude, Longitude, LoggedInEmailAddress) {
                var location = new IntelliServe_Dxtreme.TeamLocationViewModel();

                location.Oid = ko.observable(guid());
                location.Latitude = ko.observable(Latitude);
                location.Longitude = ko.observable(Longitude);
                location.LoggedInEmailAddress = ko.observable(LoggedInEmailAddress);
                location.TeamLocationType = ko.observable(0);
                location.DateTime = ko.observable(new Date());

                return IntelliServe_Dxtreme.db.TeamLocations.insert(location.toJS());
            };

            var pInsertJobCardNote = function (jobcardid, Description) {
                var note = new IntelliServe_Dxtreme.JobCardNoteViewModel();

                note.Oid = ko.observable(guid());
                note.Description = ko.observable(Description);
                note.DateTime = ko.observable(new Date());
                note.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                return IntelliServe_Dxtreme.db.JobCardNotes.insert(note.toJS());
            };

            var pInsertJobCardItem = function (jobcardid, Item, Quantity) {
                var item = new IntelliServe_Dxtreme.JobCardItemViewModel();

                item.Oid = ko.observable(guid());
                item.Item1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Items', Item.Oid()));
                item.Quantity = ko.observable(Quantity);
                item.Description = ko.observable(Item.Description());
                item.CostPrice = ko.observable(Item.CostPrice());
                item.SellingPrice = ko.observable(Item.SellingPrice());
                item.VAT = ko.observable(Item.VAT());
                item.IsAdditional = ko.observable(true);
                item.DateTime = ko.observable(new Date());
                item.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                return IntelliServe_Dxtreme.db.JobCardItems.insert(item.toJS());
            };

            //var pInsertJobCardItem = function (jobcardid, Item, Quantity) {
            //    var item = new IntelliServe_Dxtreme.JobCardItemViewModel();

            //    item.Oid = ko.observable(guid());
            //    item.Item = ko.observable(IntelliServe_Dxtreme.db.objectLink('Items', Item.Oid()));
            //    item.Quantity = ko.observable(Quantity);
            //    item.Description = ko.observable(Item.Description());
            //    item.CostPrice = ko.observable(Item.CostPrice());
            //    item.SellingPrice = ko.observable(Item.SellingPrice());
            //    item.VAT = ko.observable(Item.VAT());
            //    item.IsAdditional = ko.observable(true);
            //    item.DateTime = ko.observable(new Date());
            //    item.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

            //    return IntelliServe_Dxtreme.db.JobCardItems.insert(item.toJS());
            //};

            var pUpdateJobCardItem = function (id, jobCardItem, Item, Quantity) {
                jobCardItem.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobCardItem.JobCard1().Oid()));
                jobCardItem.Item1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Items', jobCardItem.Item1().Oid()));
                jobCardItem.Description = ko.observable(Item.Description().toString());
                return IntelliServe_Dxtreme.db.JobCardItems.update(id, jobCardItem.toJS());
            };

            //var pUpdateJobCardItem = function (id, jobCardItem) {
            //    jobCardItem.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobCardItem.JobCard1().Oid()));
            //    jobCardItem.Item1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Items', jobCardItem.Item1().Oid()));
            //    jobCardItem.Description = ko.observable(jobCardItem.Description());
            //    return IntelliServe_Dxtreme.db.JobCardItems.update(id, jobCardItem.toJS());
            //};

            var pUpdateJobCardEquipment = function (id, jobCardEquipment) {
                jobCardEquipment.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobCardEquipment.JobCard1().Oid()));
                jobCardEquipment.Equipment1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Equipments', jobCardEquipment.Equipment1().Oid()));
                jobCardEquipment.FaultType1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('FaultTypes', jobCardEquipment.FaultType1().Oid()));
                return IntelliServe_Dxtreme.db.JobCardEquipments.update(id, jobCardEquipment.toJS());
            };

            var pInsertJobCardEquipment = function (id, jobCardEquipment) {
                jobCardEquipment.Oid = ko.observable(guid());
                jobCardEquipment.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', id));
                jobCardEquipment.Equipment1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Equipments', jobCardEquipment.Equipment1()));
                jobCardEquipment.FaultType1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('FaultTypes', jobCardEquipment.FaultType1()));
                return IntelliServe_Dxtreme.db.JobCardEquipments.insert(jobCardEquipment.toJS());
            };

            var pInsertMobileJobCardItem = function (jobcardid, Item, Quantity) {
                var item = new IntelliServe_Dxtreme.MobileJobCardItemViewModel();

                item.Oid = ko.observable(guid());
                item.Item1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Items', Item.Oid()));
                item.Quantity = ko.observable(Quantity);
                item.MobileJobCard = ko.observable(IntelliServe_Dxtreme.db.objectLink('MobileJobCards', jobcardid));

                return IntelliServe_Dxtreme.db.MobileJobCardItems.insert(item.toJS());
            };

            var pInsertMobileBase = function () {
                var item = new IntelliServe_Dxtreme.MobileBaseViewModel();

                item.Oid = ko.observable(guid());

                return IntelliServe_Dxtreme.db.MobileBases.insert(item.toJS());
            };

            var pUpdateMobileBaseReceived = function (id) {
                var item = new IntelliServe_Dxtreme.MobileBaseViewModel();

                IntelliServe_Dxtreme.db.MobileBases.byKey(id).done(function (data) {
                    item.fromJS(data);
                });

                item.DateReceived = ko.observable(new Date());

                return IntelliServe_Dxtreme.db.MobileBases.update(id,item.toJS());
            };

            function load() {
                return IntelliServe_Dxtreme.db.QuoteItems.byKey(id, { expand: ["Quote1", "Item"] }).done(function (data) {
                    quoteitem.fromJS(data);
                });
            }

            function update() {
                IntelliServe_Dxtreme.db.QuoteItems.update(id, quoteitem.toJS()).done(function () {
                    IntelliServe_Dxtreme.app.back();
                });
            }

            var pInsertAddressBase = function(Latitude, Longitude) {
                var item = new IntelliServe_Dxtreme.AddressBasViewModel();

                item.Oid = ko.observable(guid());
                item.Latitude = ko.observable(Latitude);
                item.Longitude = ko.observable(Longitude);

                return IntelliServe_Dxtreme.db.AddressBases.insert(item.toJS());
            };

            var pInsertClientBase = function (ClientBase,Address) {
                ClientBase.Oid = ko.observable(guid());
                ClientBase.PostalAddress = ko.observable(Address.Oid);

                return IntelliServe_Dxtreme.db.ClientBases.insert(ClientBase.toJS());
            };

            var pInsertLocationClient = function (AddressOid, ClientOid,ClientContactOid) {
                var item = new IntelliServe_Dxtreme.LocationViewModel();

                item.Oid = ko.observable(guid());

                item.Client1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Clients', ClientOid));
                item.AddressBase = ko.observable(IntelliServe_Dxtreme.db.objectLink('AddressBases', AddressOid));
                item.ClientContact1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('ClientContacts', ClientContactOid));

                return IntelliServe_Dxtreme.db.Locations.insert(item.toJS());
            };

            var pInsertClientContact = function (ClientBase) {
                var item = new IntelliServe_Dxtreme.ClientContactViewModel();

                item.Oid = ko.observable(guid());
                item.Client1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Clients', ClientBase.Oid));
                item.FirstName = ko.observable(ClientBase.FirstName);
                item.LastName = ko.observable(ClientBase.LastName);
                item.Email = ko.observable(ClientBase.Email);
                item.CellNo = ko.observable(ClientBase.CellNo);
                item.Phone = ko.observable(ClientBase.Phone);

                return IntelliServe_Dxtreme.db.ClientContacts.insert(item.toJS());
            };

            var pInsertClient = function (ClientBase) {
                var item = new IntelliServe_Dxtreme.ClientViewModel(), data;

                item.Oid = ko.observable(ClientBase.Oid);

                data = IntelliServe_Dxtreme.db.Clients.insert(item.toJS());

                return data;
            };

            var pInsertMobileJobCard = function (Oid, MobileJobCardViewModel) {
                MobileJobCardViewModel.Oid = ko.observable(Oid);
                MobileJobCardViewModel.JobType1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobTypes', MobileJobCardViewModel.JobType1().Oid()));

                if (MobileJobCardViewModel.Client1() != null)
                    MobileJobCardViewModel.Client1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Clients', MobileJobCardViewModel.Client1().Oid()));

                if (MobileJobCardViewModel.Location1() != null)
                    MobileJobCardViewModel.Location1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('Locations', MobileJobCardViewModel.Location1().Oid()));

                MobileJobCardViewModel.CreatedBy = ko.observable(IntelliServe_Dxtreme.currentUser.UserName());

                return IntelliServe_Dxtreme.db.MobileJobCards.insert(MobileJobCardViewModel.toJS());
            };

            var pUpdateJobCardNote = function (id, jobcardid, Description) {
                var note = new IntelliServe_Dxtreme.JobCardNoteViewModel();

                note.Description = ko.observable(Description);
                note.DateTime = ko.observable(new Date());
                note.JobCard1 = ko.observable(IntelliServe_Dxtreme.db.objectLink('JobCards', jobcardid));

                return IntelliServe_Dxtreme.db.JobCardNotes.update(id, note.toJS());
            };

            return {
                GetJobcardDetails: pGetJobcardDetails,
                IsUserAllowed: pIsUserAllowed,
                InsertJobCardImage: pInsertJobCardImage,
                InsertJobCardSignature: pInsertJobCardSignature,
                InsertTeamLocation: pInsertTeamLocation,
                InsertJobCardNote: pInsertJobCardNote,
                UpdateJobCardNote: pUpdateJobCardNote,
                InsertJobCardTimeLog: pInsertJobCardTimeLog,
                UpdateJobCardTimeLog: pUpdateJobCardTimeLog,
                InsertJobCardItem: pInsertJobCardItem,
                UpdateJobCardItem: pUpdateJobCardItem,
                GetDatabases: pGetDatabases,
                ItemDetails: pItemDetails,
                GetJobcardItems: pGetJobcardItems,
                GetJobcardEquipments: pGetJobcardEquipments,
                InsertMobileJobCard: pInsertMobileJobCard,
                JobTypeDetails: pJobTypeDetails,
                ClientDetails: pClientDetails,
                LocationDetails: pLocationDetails,
                InsertMobileBase: pInsertMobileBase,
                InsertMobileJobCardItem: pInsertMobileJobCardItem,
                GetClientContacts: pGetClientContacts,
                GetJobcardCheckList: pGetJobcardCheckList,
                GetJobcardCheckListItems: pGetJobcardCheckListItems,
                InsertClientBase: pInsertClientBase,
                InsertClient: pInsertClient,
                InsertAddressBase: pInsertAddressBase,
                InsertClientContact: pInsertClientContact,
                GetCheckLists: pGetCheckLists,
                InsertJobCardCheckList: pInsertJobCardCheckList,
                GetCheckListItems: pGetCheckListItems,
                DefaultStatus: pDefaultStatus,
                UpdateMobileBaseReceived: pUpdateMobileBaseReceived,
                InsertLocationClient: pInsertLocationClient,
                UpdateJobCardEquipment: pUpdateJobCardEquipment,
                InsertJobCardEquipment: pInsertJobCardEquipment,
                GetJobcardAttachments: pGetJobcardAttachments,
                CustomStatus: pCustomStatus,
                GetJobcardDetailsClosed: pGetJobcardDetailsClosed
            };
        }

        return {
            Instance: function () {
                if (!_instance) {
                    _instance = CreateDataLayer();
                }
                return _instance;
            }
        };
    }();
})();