(function() {
    IntelliServe_Dxtreme.EventViewModel = function(data) {
            this.Oid = ko.observable();
            this.ResourceIds = ko.observable();
            this.Event2 = ko.observable();
            this.Subject = ko.observable();
            this.Description = ko.observable();
            this.StartOn = ko.observable();
            this.EndOn = ko.observable();
            this.AllDay = ko.observable();
            this.Location = ko.observable();
            this.Label = ko.observable();
            this.Status = ko.observable();
            this.Type = ko.observable();
            this.RemindIn = ko.observable();
            this.ReminderInfoXml = ko.observable();
            this.AlarmTime = ko.observable();
            this.IsPostponed = ko.observable();
            this.RecurrenceInfoXml = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.XPObjectType = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.EventViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                ResourceIds: this.ResourceIds(),
                Event2: IntelliServe_Dxtreme.db.objectLink("Events", this.Event2() ? this.Event2().Oid(): undefined),
                Subject: this.Subject(),
                Description: this.Description(),
                StartOn: this.StartOn(),
                EndOn: this.EndOn(),
                AllDay: this.AllDay(),
                Location: this.Location(),
                Label: this.Label(),
                Status: this.Status(),
                Type: this.Type(),
                RemindIn: this.RemindIn(),
                ReminderInfoXml: this.ReminderInfoXml(),
                AlarmTime: this.AlarmTime(),
                IsPostponed: this.IsPostponed(),
                RecurrenceInfoXml: this.RecurrenceInfoXml(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                XPObjectType: IntelliServe_Dxtreme.db.objectLink("XPObjectTypes", this.XPObjectType() ? this.XPObjectType().OID(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.ResourceIds(data.ResourceIds);
                if(data.Event2)
                    this.Event2(new IntelliServe_Dxtreme.EventViewModel(data.Event2));
                this.Subject(data.Subject);
                this.Description(data.Description);
                this.StartOn(data.StartOn);
                this.EndOn(data.EndOn);
                this.AllDay(data.AllDay);
                this.Location(data.Location);
                this.Label(data.Label);
                this.Status(data.Status);
                this.Type(data.Type);
                this.RemindIn(data.RemindIn);
                this.ReminderInfoXml(data.ReminderInfoXml);
                this.AlarmTime(data.AlarmTime);
                this.IsPostponed(data.IsPostponed);
                this.RecurrenceInfoXml(data.RecurrenceInfoXml);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                if(data.XPObjectType)
                    this.XPObjectType(new IntelliServe_Dxtreme.XPObjectTypeViewModel(data.XPObjectType));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.ResourceIds(undefined);
            this.Event2(undefined);
            this.Subject(undefined);
            this.Description(undefined);
            this.StartOn(undefined);
            this.EndOn(undefined);
            this.AllDay(undefined);
            this.Location(undefined);
            this.Label(undefined);
            this.Status(undefined);
            this.Type(undefined);
            this.RemindIn(undefined);
            this.ReminderInfoXml(undefined);
            this.AlarmTime(undefined);
            this.IsPostponed(undefined);
            this.RecurrenceInfoXml(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.XPObjectType(undefined);
        }
    });
})();