(function() {
    IntelliServe_Dxtreme.InventoryLocationViewModel = function(data) {
            this.Oid = ko.observable();
            this.Location = ko.observable();
            this.User = ko.observable();
            this.DefaultLocation = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.InventoryLocationViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Location: this.Location(),
                User: IntelliServe_Dxtreme.db.objectLink("Users", this.User() ? this.User().Oid(): undefined),
                DefaultLocation: this.DefaultLocation(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Location(data.Location);
                if(data.User)
                    this.User(new IntelliServe_Dxtreme.UserViewModel(data.User));
                this.DefaultLocation(data.DefaultLocation);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Location(undefined);
            this.User(undefined);
            this.DefaultLocation(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();