(function () {
    IntelliServe_Dxtreme.ItemViewModel = function (data) {
        this.Oid = ko.observable();
        this.StockCode = ko.observable();
        this.Description = ko.observable();
        this.CostPrice = ko.observable();
        this.SellingPrice = ko.observable();
        this.ItemType = ko.observable();
        this.OptimisticLockField = ko.observable();
        this.ItemCategory = ko.observable();
        this.PriceLastAdjusted = ko.observable();
        this.GCRecord = ko.observable();
        this.VAT = ko.observable();
        if (data)
            this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.ItemViewModel.prototype, {
        toJS: function () {
            return {
                Oid: this.Oid(),
                StockCode: this.StockCode(),
                Description: this.Description(),
                CostPrice: this.CostPrice(),
                SellingPrice: this.SellingPrice(),
                ItemType: this.ItemType(),
                OptimisticLockField: this.OptimisticLockField(),
                ItemCategory: IntelliServe_Dxtreme.db.objectLink("ItemCategories", this.ItemCategory() ? this.ItemCategory().Oid() : undefined),
                PriceLastAdjusted: this.PriceLastAdjusted(),
                GCRecord: this.GCRecord(),
                VAT: this.VAT(),
            };
        },

        fromJS: function (data) {
            if (data) {
                this.Oid(data.Oid);
                this.StockCode(data.StockCode);
                this.Description(data.Description);
                this.CostPrice(data.CostPrice);
                this.SellingPrice(data.SellingPrice);
                this.ItemType(data.ItemType);
                this.OptimisticLockField(data.OptimisticLockField);
                if (data.ItemCategory)
                    this.ItemCategory(new IntelliServe_Dxtreme.ItemCategoryViewModel(data.ItemCategory));
                this.PriceLastAdjusted(data.PriceLastAdjusted);
                this.GCRecord(data.GCRecord);
                this.VAT(data.VAT);
            }
        },

        clear: function () {
            this.Oid(undefined);
            this.StockCode(undefined);
            this.Description(undefined);
            this.CostPrice(undefined);
            this.SellingPrice(undefined);
            this.ItemType(undefined);
            this.OptimisticLockField(undefined);
            this.ItemCategory(undefined);
            this.PriceLastAdjusted(undefined);
            this.GCRecord(undefined);
            this.VAT(undefined);
        }
    });
})();