(function() {
    IntelliServe_Dxtreme.JobProjectViewModel = function(data) {
            this.Oid = ko.observable();
            this.ProjectNumber = ko.observable();
            this.User1 = ko.observable();
            this.Client1 = ko.observable();
            this.Team1 = ko.observable();
            this.Location = ko.observable();
            this.DateOfIssue = ko.observable();
            this.ReferenceNumber = ko.observable();
            this.PolicyNumber = ko.observable();
            this.Notes = ko.observable();
            this.Priority = ko.observable();
            this.PriorityDescription = ko.observable();
            this.StatusDescription = ko.observable();
            this.BookedTime = ko.observable();
            this.BookedTimeEnd = ko.observable();
            this.ConvertedToInvoice = ko.observable();
            this.ConvertedToQuote = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.CustomStatu = ko.observable();
            this.StatusCompleted = ko.observable();
            this.CustomStatu1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.JobProjectViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                ProjectNumber: this.ProjectNumber(),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                Team1: IntelliServe_Dxtreme.db.objectLink("Teams", this.Team1() ? this.Team1().Oid(): undefined),
                Location: IntelliServe_Dxtreme.db.objectLink("Locations", this.Location() ? this.Location().Oid(): undefined),
                DateOfIssue: this.DateOfIssue(),
                ReferenceNumber: this.ReferenceNumber(),
                PolicyNumber: this.PolicyNumber(),
                Notes: this.Notes(),
                Priority: this.Priority(),
                PriorityDescription: this.PriorityDescription(),
                StatusDescription: this.StatusDescription(),
                BookedTime: this.BookedTime(),
                BookedTimeEnd: this.BookedTimeEnd(),
                ConvertedToInvoice: this.ConvertedToInvoice(),
                ConvertedToQuote: this.ConvertedToQuote(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                CustomStatu: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu() ? this.CustomStatu().Oid(): undefined),
                StatusCompleted: this.StatusCompleted(),
                CustomStatu1: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu1() ? this.CustomStatu1().Oid(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.ProjectNumber(data.ProjectNumber);
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                if(data.Team1)
                    this.Team1(new IntelliServe_Dxtreme.TeamViewModel(data.Team1));
                if(data.Location)
                    this.Location(new IntelliServe_Dxtreme.LocationViewModel(data.Location));
                this.DateOfIssue(data.DateOfIssue);
                this.ReferenceNumber(data.ReferenceNumber);
                this.PolicyNumber(data.PolicyNumber);
                this.Notes(data.Notes);
                this.Priority(data.Priority);
                this.PriorityDescription(data.PriorityDescription);
                this.StatusDescription(data.StatusDescription);
                this.BookedTime(data.BookedTime);
                this.BookedTimeEnd(data.BookedTimeEnd);
                this.ConvertedToInvoice(data.ConvertedToInvoice);
                this.ConvertedToQuote(data.ConvertedToQuote);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                if(data.CustomStatu)
                    this.CustomStatu(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu));
                this.StatusCompleted(data.StatusCompleted);
                if(data.CustomStatu1)
                    this.CustomStatu1(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.ProjectNumber(undefined);
            this.User1(undefined);
            this.Client1(undefined);
            this.Team1(undefined);
            this.Location(undefined);
            this.DateOfIssue(undefined);
            this.ReferenceNumber(undefined);
            this.PolicyNumber(undefined);
            this.Notes(undefined);
            this.Priority(undefined);
            this.PriorityDescription(undefined);
            this.StatusDescription(undefined);
            this.BookedTime(undefined);
            this.BookedTimeEnd(undefined);
            this.ConvertedToInvoice(undefined);
            this.ConvertedToQuote(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.CustomStatu(undefined);
            this.StatusCompleted(undefined);
            this.CustomStatu1(undefined);
        }
    });
})();