(function() {
    IntelliServe_Dxtreme.PartyViewModel = function(data) {
            this.Oid = ko.observable();
            this.Photo = ko.observable();
            this.Address = ko.observable();
            this.Address3 = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.XPObjectType = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.PartyViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Photo: this.Photo(),
                Address: IntelliServe_Dxtreme.db.objectLink("Addresses", this.Address() ? this.Address().Oid(): undefined),
                Address3: IntelliServe_Dxtreme.db.objectLink("Addresses", this.Address3() ? this.Address3().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                XPObjectType: IntelliServe_Dxtreme.db.objectLink("XPObjectTypes", this.XPObjectType() ? this.XPObjectType().OID(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.Photo(data.Photo);
                if(data.Address)
                    this.Address(new IntelliServe_Dxtreme.AddressViewModel(data.Address));
                if(data.Address3)
                    this.Address3(new IntelliServe_Dxtreme.AddressViewModel(data.Address3));
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                if(data.XPObjectType)
                    this.XPObjectType(new IntelliServe_Dxtreme.XPObjectTypeViewModel(data.XPObjectType));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Photo(undefined);
            this.Address(undefined);
            this.Address3(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.XPObjectType(undefined);
        }
    });
})();