(function() {
    IntelliServe_Dxtreme.PaymentViewModel = function(data) {
            this.Oid = ko.observable();
            this.Invoice1 = ko.observable();
            this.PaymentDate = ko.observable();
            this.PaymentAmount = ko.observable();
            this.User1 = ko.observable();
            this.Transaction1 = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.PaymentType = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.PaymentViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                PaymentDate: this.PaymentDate(),
                PaymentAmount: this.PaymentAmount(),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                Transaction1: IntelliServe_Dxtreme.db.objectLink("Transactions", this.Transaction1() ? this.Transaction1().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                PaymentType: this.PaymentType(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                this.PaymentDate(data.PaymentDate);
                this.PaymentAmount(data.PaymentAmount);
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                if(data.Transaction1)
                    this.Transaction1(new IntelliServe_Dxtreme.TransactionViewModel(data.Transaction1));
                this.OptimisticLockField(data.OptimisticLockField);
                this.PaymentType(data.PaymentType);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Invoice1(undefined);
            this.PaymentDate(undefined);
            this.PaymentAmount(undefined);
            this.User1(undefined);
            this.Transaction1(undefined);
            this.OptimisticLockField(undefined);
            this.PaymentType(undefined);
            this.GCRecord(undefined);
        }
    });
})();