(function() {
    IntelliServe_Dxtreme.QuoteItemViewModel = function(data) {
            this.Oid = ko.observable();
            this.Quote1 = ko.observable();
            this.Item = ko.observable();
            this.Description = ko.observable();
            this.CostPrice = ko.observable();
            this.SellingPrice = ko.observable();
            this.Quantity = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.DateTime = ko.observable();
            this.VAT = ko.observable();
            this.VatPercentage = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.QuoteItemViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Quote1: IntelliServe_Dxtreme.db.objectLink("Quotes", this.Quote1() ? this.Quote1().Oid(): undefined),
                Item: IntelliServe_Dxtreme.db.objectLink("Items", this.Item() ? this.Item().Oid(): undefined),
                Description: this.Description(),
                CostPrice: this.CostPrice(),
                SellingPrice: this.SellingPrice(),
                Quantity: this.Quantity(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                DateTime: this.DateTime(),
                VAT: this.VAT(),
                VatPercentage: this.VatPercentage(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Quote1)
                    this.Quote1(new IntelliServe_Dxtreme.QuoteViewModel(data.Quote1));
                if(data.Item)
                    this.Item(new IntelliServe_Dxtreme.ItemViewModel(data.Item));
                this.Description(data.Description);
                this.CostPrice(data.CostPrice);
                this.SellingPrice(data.SellingPrice);
                this.Quantity(data.Quantity);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                this.DateTime(data.DateTime);
                this.VAT(data.VAT);
                this.VatPercentage(data.VatPercentage);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Quote1(undefined);
            this.Item(undefined);
            this.Description(undefined);
            this.CostPrice(undefined);
            this.SellingPrice(undefined);
            this.Quantity(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.DateTime(undefined);
            this.VAT(undefined);
            this.VatPercentage(undefined);
        }
    });
})();