(function() {
    IntelliServe_Dxtreme.TeamBasViewModel = function(data) {
            this.Oid = ko.observable();
            this.TeamName = ko.observable();
            this.Email = ko.observable();
            this.Cell = ko.observable();
            this.Area = ko.observable();
            this.TeamType = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.XPObjectType = ko.observable();
            this.Color = ko.observable();
            this.Resource1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TeamBasViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                TeamName: this.TeamName(),
                Email: this.Email(),
                Cell: this.Cell(),
                Area: this.Area(),
                TeamType: IntelliServe_Dxtreme.db.objectLink("TeamTypes", this.TeamType() ? this.TeamType().Oid(): undefined),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                Color: this.Color(),
                Resource1: IntelliServe_Dxtreme.db.objectLink("Resources", this.Resource1() ? this.Resource1().Oid(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.TeamName(data.TeamName);
                this.Email(data.Email);
                this.Cell(data.Cell);
                this.Area(data.Area);
                if(data.TeamType)
                    this.TeamType(new IntelliServe_Dxtreme.TeamTypeViewModel(data.TeamType));
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                this.Color(data.Color);
                if(data.Resource1)
                    this.Resource1(new IntelliServe_Dxtreme.ResourceViewModel(data.Resource1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.TeamName(undefined);
            this.Email(undefined);
            this.Cell(undefined);
            this.Area(undefined);
            this.TeamType(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.Color(undefined);
            this.Resource1(undefined);
        }
    });
})();