(function() {
    IntelliServe_Dxtreme.TicketViewModel = function(data) {
            this.Oid = ko.observable();
            this.TicketNumber = ko.observable();
            this.Email = ko.observable();
            this.JobCard1 = ko.observable();
            this.Quote1 = ko.observable();
            this.Invoice1 = ko.observable();
            this.ConvertedToJobCard = ko.observable();
            this.ConvertedToQuote = ko.observable();
            this.ConvertedToInvoice = ko.observable();
            this.DateOfIssue = ko.observable();
            this.ClientContact1 = ko.observable();
            this.Subject = ko.observable();
            this.Description = ko.observable();
            this.JobType1 = ko.observable();
            this.Priority = ko.observable();
            this.PriorityDescription = ko.observable();
            this.User2 = ko.observable();
            this.User1 = ko.observable();
            this.StatusDescription = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            this.CustomStatu = ko.observable();
            this.StatusCompleted = ko.observable();
            this.CustomStatu1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TicketViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                TicketNumber: this.TicketNumber(),
                Email: this.Email(),
                JobCard1: IntelliServe_Dxtreme.db.objectLink("JobCards", this.JobCard1() ? this.JobCard1().Oid(): undefined),
                Quote1: IntelliServe_Dxtreme.db.objectLink("Quotes", this.Quote1() ? this.Quote1().Oid(): undefined),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                ConvertedToJobCard: this.ConvertedToJobCard(),
                ConvertedToQuote: this.ConvertedToQuote(),
                ConvertedToInvoice: this.ConvertedToInvoice(),
                DateOfIssue: this.DateOfIssue(),
                ClientContact1: IntelliServe_Dxtreme.db.objectLink("ClientContacts", this.ClientContact1() ? this.ClientContact1().Oid(): undefined),
                Subject: this.Subject(),
                Description: this.Description(),
                JobType1: IntelliServe_Dxtreme.db.objectLink("JobTypes", this.JobType1() ? this.JobType1().Oid(): undefined),
                Priority: this.Priority(),
                PriorityDescription: this.PriorityDescription(),
                User2: IntelliServe_Dxtreme.db.objectLink("Users", this.User2() ? this.User2().Oid(): undefined),
                User1: IntelliServe_Dxtreme.db.objectLink("Users", this.User1() ? this.User1().Oid(): undefined),
                StatusDescription: this.StatusDescription(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
                CustomStatu: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu() ? this.CustomStatu().Oid(): undefined),
                StatusCompleted: this.StatusCompleted(),
                CustomStatu1: IntelliServe_Dxtreme.db.objectLink("CustomStatus", this.CustomStatu1() ? this.CustomStatu1().Oid(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                this.TicketNumber(data.TicketNumber);
                this.Email(data.Email);
                if(data.JobCard1)
                    this.JobCard1(new IntelliServe_Dxtreme.JobCardViewModel(data.JobCard1));
                if(data.Quote1)
                    this.Quote1(new IntelliServe_Dxtreme.QuoteViewModel(data.Quote1));
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                this.ConvertedToJobCard(data.ConvertedToJobCard);
                this.ConvertedToQuote(data.ConvertedToQuote);
                this.ConvertedToInvoice(data.ConvertedToInvoice);
                this.DateOfIssue(data.DateOfIssue);
                if(data.ClientContact1)
                    this.ClientContact1(new IntelliServe_Dxtreme.ClientContactViewModel(data.ClientContact1));
                this.Subject(data.Subject);
                this.Description(data.Description);
                if(data.JobType1)
                    this.JobType1(new IntelliServe_Dxtreme.JobTypeViewModel(data.JobType1));
                this.Priority(data.Priority);
                this.PriorityDescription(data.PriorityDescription);
                if(data.User2)
                    this.User2(new IntelliServe_Dxtreme.UserViewModel(data.User2));
                if(data.User1)
                    this.User1(new IntelliServe_Dxtreme.UserViewModel(data.User1));
                this.StatusDescription(data.StatusDescription);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
                if(data.CustomStatu)
                    this.CustomStatu(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu));
                this.StatusCompleted(data.StatusCompleted);
                if(data.CustomStatu1)
                    this.CustomStatu1(new IntelliServe_Dxtreme.CustomStatuViewModel(data.CustomStatu1));
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.TicketNumber(undefined);
            this.Email(undefined);
            this.JobCard1(undefined);
            this.Quote1(undefined);
            this.Invoice1(undefined);
            this.ConvertedToJobCard(undefined);
            this.ConvertedToQuote(undefined);
            this.ConvertedToInvoice(undefined);
            this.DateOfIssue(undefined);
            this.ClientContact1(undefined);
            this.Subject(undefined);
            this.Description(undefined);
            this.JobType1(undefined);
            this.Priority(undefined);
            this.PriorityDescription(undefined);
            this.User2(undefined);
            this.User1(undefined);
            this.StatusDescription(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
            this.CustomStatu(undefined);
            this.StatusCompleted(undefined);
            this.CustomStatu1(undefined);
        }
    });
})();