(function() {
    IntelliServe_Dxtreme.TransactionViewModel = function(data) {
            this.Oid = ko.observable();
            this.Invoice1 = ko.observable();
            this.CreditNote1 = ko.observable();
            this.Payment1 = ko.observable();
            this.Client1 = ko.observable();
            this.Debit = ko.observable();
            this.Credit = ko.observable();
            this.TransactionDate = ko.observable();
            this.OptimisticLockField = ko.observable();
            this.GCRecord = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.TransactionViewModel.prototype, {
        toJS: function() {
            return {
                Oid: this.Oid(),
                Invoice1: IntelliServe_Dxtreme.db.objectLink("Invoices", this.Invoice1() ? this.Invoice1().Oid(): undefined),
                CreditNote1: IntelliServe_Dxtreme.db.objectLink("CreditNotes", this.CreditNote1() ? this.CreditNote1().Oid(): undefined),
                Payment1: IntelliServe_Dxtreme.db.objectLink("Payments", this.Payment1() ? this.Payment1().Oid(): undefined),
                Client1: IntelliServe_Dxtreme.db.objectLink("Clients", this.Client1() ? this.Client1().Oid(): undefined),
                Debit: this.Debit(),
                Credit: this.Credit(),
                TransactionDate: this.TransactionDate(),
                OptimisticLockField: this.OptimisticLockField(),
                GCRecord: this.GCRecord(),
            };
        },

        fromJS: function(data) {
            if(data) {
                this.Oid(data.Oid);
                if(data.Invoice1)
                    this.Invoice1(new IntelliServe_Dxtreme.InvoiceViewModel(data.Invoice1));
                if(data.CreditNote1)
                    this.CreditNote1(new IntelliServe_Dxtreme.CreditNoteViewModel(data.CreditNote1));
                if(data.Payment1)
                    this.Payment1(new IntelliServe_Dxtreme.PaymentViewModel(data.Payment1));
                if(data.Client1)
                    this.Client1(new IntelliServe_Dxtreme.ClientViewModel(data.Client1));
                this.Debit(data.Debit);
                this.Credit(data.Credit);
                this.TransactionDate(data.TransactionDate);
                this.OptimisticLockField(data.OptimisticLockField);
                this.GCRecord(data.GCRecord);
            }
        },

        clear: function() {
            this.Oid(undefined);
            this.Invoice1(undefined);
            this.CreditNote1(undefined);
            this.Payment1(undefined);
            this.Client1(undefined);
            this.Debit(undefined);
            this.Credit(undefined);
            this.TransactionDate(undefined);
            this.OptimisticLockField(undefined);
            this.GCRecord(undefined);
        }
    });
})();