(function() {
    IntelliServe_Dxtreme.UserViewModel = function(data) {
            this.UserBaseMultiTenant = ko.observable();
            this.Oid = ko.observable();
            this.Group1 = ko.observable();
            this.User2 = ko.observable();
            this.InventoryLocation1 = ko.observable();
            if(data)
                this.fromJS(data);
    };

    $.extend(IntelliServe_Dxtreme.UserViewModel.prototype, {
        toJS: function() {
            return {
                UserBaseMultiTenant: IntelliServe_Dxtreme.db.objectLink("UserBaseMultiTenants", this.UserBaseMultiTenant() ? this.UserBaseMultiTenant().Oid(): undefined),
                Oid: this.Oid(),
                Group1: IntelliServe_Dxtreme.db.objectLink("Groups", this.Group1() ? this.Group1().Oid(): undefined),
                User2: IntelliServe_Dxtreme.db.objectLink("Users", this.User2() ? this.User2().Oid(): undefined),
                InventoryLocation1: IntelliServe_Dxtreme.db.objectLink("InventoryLocations", this.InventoryLocation1() ? this.InventoryLocation1().Oid(): undefined),
            };
        },

        fromJS: function(data) {
            if(data) {
                if(data.UserBaseMultiTenant)
                    this.UserBaseMultiTenant(new IntelliServe_Dxtreme.UserBaseMultiTenantViewModel(data.UserBaseMultiTenant));
                this.Oid(data.Oid);
                if(data.Group1)
                    this.Group1(new IntelliServe_Dxtreme.GroupViewModel(data.Group1));
                if(data.User2)
                    this.User2(new IntelliServe_Dxtreme.UserViewModel(data.User2));
                if(data.InventoryLocation1)
                    this.InventoryLocation1(new IntelliServe_Dxtreme.InventoryLocationViewModel(data.InventoryLocation1));
            }
        },

        clear: function() {
            this.UserBaseMultiTenant(undefined);
            this.Oid(undefined);
            this.Group1(undefined);
            this.User2(undefined);
            this.InventoryLocation1(undefined);
        }
    });
})();