$(function() {
    var startupView = IntelliServe_Dxtreme.currentUser.IsAuthenticated() === "false" ? "Home" : "Stats";

    // Uncomment the line below to disable platform-specific look and feel and to use the Generic theme for all devices
    DevExpress.devices.current({ platform: "generic" });

    DevExpress.utils.initMobileViewport({ allowZoom: false, allowPan: false, allowSelection: false });

    if(DevExpress.devices.real().platform === "win") {
        $("body").css("background-color", "#000");
    }

    $(document).on("deviceready", function () {
        navigator.splashscreen.hide();
        $(document).on("backbutton", function () {
            DevExpress.processHardwareBackButton();
        });
    });

    setInterval(function () {
        if (IntelliServe_Dxtreme.currentUser.UserName() !== "") {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    IntelliServe_Dxtreme.dbDataLayer.Instance().InsertTeamLocation(position.coords.latitude, position.coords.longitude, IntelliServe_Dxtreme.currentUser.UserName());
                });
            }
        }
    }, 300000);

    function onNavigatingBack(e) {
        if(e.isHardwareButton && !IntelliServe_Dxtreme.app.canBack()) {
            e.cancel = true;
            exitApp();
        }
    }

    function exitApp() {
        switch (DevExpress.devices.real().platform) {
            case "android":
                navigator.app.exitApp();
                break;
            case "win":
                MSApp.terminateApp('');
                break;
        }
    }

    var layoutSet = DevExpress.framework.html.layoutSets[IntelliServe_Dxtreme.config.layoutSet],
        navigation = IntelliServe_Dxtreme.config.navigation, navigationLoggedIn = IntelliServe_Dxtreme.config.navigationLoggedIn;


    IntelliServe_Dxtreme.app = new DevExpress.framework.html.HtmlApplication({
        namespace: IntelliServe_Dxtreme,
        layoutSet: layoutSet,
        animationSet: DevExpress.framework.html.animationSets[IntelliServe_Dxtreme.config.animationSet],
        navigation: IntelliServe_Dxtreme.currentUser.IsAuthenticated() === "true" ? navigationLoggedIn : navigation,
        commandMapping: IntelliServe_Dxtreme.config.commandMapping,
        navigateToRootViewMode: "keepHistory",
        useViewTitleAsBackText: true
    });

    $(window).unload(function() {
        IntelliServe_Dxtreme.app.saveState();
    });

    IntelliServe_Dxtreme.app.router.register(":view/:id", { view: startupView, id: undefined });
    IntelliServe_Dxtreme.app.on("navigatingBack", onNavigatingBack);
    IntelliServe_Dxtreme.app.navigate();
});