﻿IntelliServe_Dxtreme.ClientAdd = function (params, viewInfo) {
    "use strict";

    var clientValidationRules, clientEmailValidationRules, clientPhoneValidationRules,
        isSplitLayout = viewInfo.layoutController.name === "split",
        client = new IntelliServe_Dxtreme.ClientBasViewModel(),
        isReady = $.Deferred();

    function insert() {
        var AddressOid, ClientOid, ClientContactOid;

        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function (position) {
                IntelliServe_Dxtreme.dbDataLayer.Instance().InsertAddressBase(position.coords.latitude, position.coords.longitude).done(function (data) {
                    AddressOid = data.Oid;

                    IntelliServe_Dxtreme.dbDataLayer.Instance().InsertClientBase(client, data).done(function (data) {
                        ClientOid = data.Oid;

                        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertClient(data).done(function () {
                            IntelliServe_Dxtreme.dbDataLayer.Instance().InsertClientContact(data).done(function (data) {
                                ClientContactOid = data.Oid;

                                IntelliServe_Dxtreme.dbDataLayer.Instance().InsertLocationClient(AddressOid, ClientOid, ClientContactOid).done(function () {
                                    IntelliServe_Dxtreme.app.navigate("Stats", { target: "current", clearHistory: true });

                                    DevExpress.ui.notify("Client Successfully Addded", 'Success', 3000);
                                });
                            });
                        });
                    });
                });
            });
        }
    }

    function handleSave() {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            insert();
        }
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.navigate("Stats", { target: "current", clearHistory: true });
    }

    function handleViewShowing() {
        client.clear();
        isReady.resolve();
    }

    clientValidationRules = {
        validationRules: [{
            type: "required"
        }]
    };

    clientEmailValidationRules = {
        validationRules: [{
            type: "email"
        }, {
            type: "required"
        }]
    };

    clientPhoneValidationRules = {
        validationRules: [{
            type: "pattern",
            pattern: /^(\+\d{1,2}\s)?\(?\d{3}\)?[\s.-]\d{3}[\s.-]\d{4}$/,
            message: 'Value not in proper format.'
        }]
    };

    var viewModel = {
        client: client,
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        clientValidationRules: clientValidationRules,
        clientEmailValidationRules: clientEmailValidationRules,
        clientPhoneValidationRules: clientPhoneValidationRules,
        isReady: isReady.promise(),
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};