﻿IntelliServe_Dxtreme.ClientContacts = function (params) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        searchString = ko.observable(''),
        dataSource;

    function handleClientContactsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if (!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load()
                .fail(function () {
                    shouldReload = true;
                })
                .always(function () {
                    isReady.resolve();
                });
        }
        else if (shouldReload) {
            refreshList();
        }
    }

    ko.computed(function () {
        return searchString();
    }).extend({
        throttle: 500
    }).subscribe(function (value) {
        dataSource.searchValue(value);
        dataSource.load().done();
    });

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.ClientContacts.off("modified", handleClientContactsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetClientContacts(id);

    IntelliServe_Dxtreme.db.ClientContacts.on("modified", handleClientContactsModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        searchString: searchString,
        find: function () {
            searchString('');
        }
    };
};