IntelliServe_Dxtreme.CustomStatuDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        customstatu = new IntelliServe_Dxtreme.CustomStatuViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.CustomStatus.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("CustomStatus", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.CustomStatus.byKey(id).done(function(data) {
            customstatu.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        customstatu: customstatu,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};