IntelliServe_Dxtreme.CustomStatuEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isNew = (id === undefined),
        isSplitLayout = viewInfo.layoutController.name === "split",
        customstatu = new IntelliServe_Dxtreme.CustomStatuViewModel(),
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.CustomStatus.byKey(id).done(function(data) {
            customstatu.fromJS(data);
        });
    }

    function update() {
        IntelliServe_Dxtreme.db.CustomStatus.update(id, customstatu.toJS()).done(function() {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function insert() {
        IntelliServe_Dxtreme.db.CustomStatus.insert(customstatu.toJS()).done(function(values, newId) {
            IntelliServe_Dxtreme.app.navigate({ view: "CustomStatuDetails", id: newId }, { target: "current" });
        });
    }

    function handleSave() {
        if(isNew)
            insert();
        else
            update();
    }

    function handleCancel() {
        if(!isNew) {
            IntelliServe_Dxtreme.app.back();
        }
        else {
            if(isSplitLayout) {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
            else {
                IntelliServe_Dxtreme.app.back();
            }
        }
    }

    function handleViewShowing() {
        customstatu.clear();
        if(!isNew)
            load().done(function() {
                isReady.resolve();
            });
        else {
            isReady.resolve();
        }
    }

    return {
        customstatu: customstatu,
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};