IntelliServe_Dxtreme.CustomStatus = function(params, viewInfo) {
    "use strict";

    var shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleCustomStatusModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if(!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load()
                .fail(function () {
                    shouldReload = true;
                })
                .always(function() {
                    isReady.resolve();
                });
        }
        else if(shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.CustomStatus.off("modified", handleCustomStatusModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = new DevExpress.data.DataSource({
        store: IntelliServe_Dxtreme.db.CustomStatus,
        map: function(item) {
            return new IntelliServe_Dxtreme.CustomStatuViewModel(item);
        }
    });

    IntelliServe_Dxtreme.db.CustomStatus.on("modified", handleCustomStatusModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot
    };   
};