IntelliServe_Dxtreme.JobCardAdd = function (params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        mobilejobcard = new IntelliServe_Dxtreme.MobileJobCardViewModel(),
        jobTypeValidationRules, bookedTimeValidationRules, bookedEndTimeValidationRules, locationValidationRules,
        clientValidationRules, onClientChange, validationResult,
        isReady = $.Deferred();

    function insert() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertMobileBase().done(function (data) {
            IntelliServe_Dxtreme.dbDataLayer.Instance().InsertMobileJobCard(data.Oid,mobilejobcard).done(function () {
                IntelliServe_Dxtreme.app.navigate("MobileJobCardItemAdd/" + data.Oid,{ target: "current", clearHistory: true });
            });
        });
    }

    function handleSave() {
        validationResult = DevExpress.validationEngine.validateModel(this);

        if (validationResult.isValid) {
            insert();
        }
    }

    function handleCancel() {
        if (isSplitLayout) {
            IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
        }
        else {
            IntelliServe_Dxtreme.app.back();
        }
    }

    function handleViewShowing() {
        mobilejobcard.clear();
        isReady.resolve();
    }

    jobTypeValidationRules = {
        validationRules: [{
            type: "required"
        }]
    };

    bookedTimeValidationRules = {
        validationRules: [{
            type: "required"
        }]
    };

    bookedEndTimeValidationRules = {
        validationRules: [{
            type: "required"
        }]
    };

    clientValidationRules = {
        validationRules: [{
            type: "custom",
            reevaluate: true,
            validationCallback: function (options) {
                return (mobilejobcard.Client1() != null) ||
                    ((options.value !== undefined) && (options.value !== null) && (options.value !== ''));
            }
        }]
    };

    locationValidationRules = {
        validationRules: [{
            type: "custom",
            reevaluate: true,
            validationCallback: function (options) {
                return (mobilejobcard.Location1() != null) ||
                    ((options.value !== undefined) && (options.value !== null) && (options.value !== ''));
            }
        }]
    };

    var viewModel = {
        mobilejobcard: mobilejobcard,
        jobTypesSource: IntelliServe_Dxtreme.dbDataLayer.Instance().JobTypeDetails(),
        clientsSource: IntelliServe_Dxtreme.dbDataLayer.Instance().ClientDetails(),
        locationsSource: ko.observable(IntelliServe_Dxtreme.dbDataLayer.Instance().LocationDetails(mobilejobcard.Client1() == null ? null : mobilejobcard.Client1().Oid())),
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        jobTypeValidationRules: jobTypeValidationRules,
        bookedTimeValidationRules: bookedTimeValidationRules,
        bookedEndTimeValidationRules: bookedEndTimeValidationRules,
        locationValidationRules: locationValidationRules,
        clientValidationRules: clientValidationRules,
        isReady: isReady.promise(),
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    viewModel.mobilejobcard.Client1.subscribe(function () {
        document.getElementById('CompanyDetails').style.visibility = 'hidden';
        document.getElementById('CompanyDetails').style.display = 'none';
        viewModel.locationsSource(IntelliServe_Dxtreme.dbDataLayer.Instance().LocationDetails(mobilejobcard.Client1() == null ? null : mobilejobcard.Client1().Oid()));
    });

    viewModel.mobilejobcard.Location1.subscribe(function () {
        document.getElementById('AddressDetails').style.visibility = 'hidden';
        document.getElementById('AddressDetails').style.display = 'none';
    });

    return viewModel;
};