﻿IntelliServe_Dxtreme.JobCardEnd = function (params) {
    "use strict";

    var id = params.id.split('|')[0],
        oid = params.id.split('|')[1],
        jobcard = new IntelliServe_Dxtreme.JobCardViewModel(),
        isReady = $.Deferred(),
        EndODO = ko.observable('');

    function load() {
        return IntelliServe_Dxtreme.db.JobCards.byKey(id, { expand: ["CustomStatu"] }).done(function (data) {
            jobcard.fromJS(data);
        });
    }

    function handleSave() {
        IntelliServe_Dxtreme.db.JobCards.update(id, jobcard.toJS()).done(function () {
            IntelliServe_Dxtreme.app.back();
        });

        IntelliServe_Dxtreme.dbDataLayer.Instance().UpdateJobCardTimeLog(oid, EndODO());
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    function handleViewShowing() {
        jobcard.clear();
        load().done(function () { isReady.resolve(); });
    }

    return {
        EndODO: EndODO,
        jobcard: jobcard,
        handleSave: handleSave,
        handleCancel: handleCancel,
        customstatusSource: {
            store: IntelliServe_Dxtreme.db.CustomStatus,
            map: function (data) {
                return new IntelliServe_Dxtreme.CustomStatuViewModel(data);
            }
        },
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};