IntelliServe_Dxtreme.JobCardStatus = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isNew = (id === undefined),
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcard = new IntelliServe_Dxtreme.JobCardViewModel(),
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.JobCards.byKey(id, { expand: ["CustomStatu"] }).done(function(data) {
            jobcard.fromJS(data);
        });
    }

    function update() {
        IntelliServe_Dxtreme.db.JobCards.update(id, jobcard.toJS()).done(function() {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function handleSave() {
        update();
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    function handleViewShowing() {
        jobcard.clear();
        load().done(function () {
            isReady.resolve();
        });
    }

    return {
        jobcard: jobcard,
        customstatusSource: IntelliServe_Dxtreme.dbDataLayer.Instance().CustomStatus(),
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};