IntelliServe_Dxtreme.JobCard = function(params, viewInfo) {
    "use strict";

    var shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        searchString = ko.observable(''),
        dataSource;

    function handlev_Jobcards_MobileModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if (IntelliServe_Dxtreme.currentUser.IsAuthenticated() == "false") {
            DevExpress.ui.notify("Please log in to view your Job Cards", 'Warning', 3000);
            IntelliServe_Dxtreme.app.navigate("Home", { target: "current", clearHistory: true });
        }
        else {
            if (!dataSourceObservable()) {
                dataSourceObservable(dataSource);
                dataSource.load()
                    .fail(function () {
                        shouldReload = true;
                    })
                    .always(function () {
                        isReady.resolve();
                    });
            }
            else if (shouldReload) {
                refreshList();
            }
        }
    }

    ko.computed(function () {
        return searchString();
    }).extend({
        throttle: 500
    }).subscribe(function (value) {
        dataSource.searchValue(value);
        dataSource.load().done();
    });

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.v_Jobcards_Mobile.off("modified", handlev_Jobcards_MobileModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetJobcardDetails();

    IntelliServe_Dxtreme.db.v_Jobcards_Mobile.on("modified", handlev_Jobcards_MobileModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot,
        searchString: searchString,
        find: function () {
            searchString('');
        },
        GetColor: function (item) {
            var colorObject = pusher.color('packed_argb', item);
            return colorObject.html('hex6');
        }
    };   
};