IntelliServe_Dxtreme.JobCardImageDescription = function (params, viewInfo) {
    "use strict";

    var id = params.id.split("|")[0],
        imageData = params.id.split("|")[1],
        Description = ko.observable(null), handleSave, descriptionValidationRules;

    handleSave = function (params) {
        var latitude, longitude;

        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    latitude = position.coords.latitude;
                    longitude = position.coords.longitude;
                });
            }

            IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardImage(id, imageData, Description, latitude, longitude).done(function () {
                DevExpress.ui.notify('Image successfully uploaded', 'success', 3000);
            })
            .fail(function () {
                DevExpress.ui.notify('Failed uploading image', 'error', 3000);
            });
        }
    }

    descriptionValidationRules = {
        validationRules: [{
            type: "required"
        }]
    };

    var viewModel = {
        handleSave: handleSave,
        Description: Description,
        descriptionValidationRules: descriptionValidationRules
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};