﻿IntelliServe_Dxtreme.JobCardMap = function (params) {
    "use strict";

    var id = params.id,
       loadPanelVisible = ko.observable(false),
       mapMarkers = ko.observableArray([]),
       mapRoutes = ko.observableArray([]),
       dxMapOptions,
       changeMarkerVisibility;

    dxMapOptions = {
        markers: mapMarkers,
        routes: mapRoutes,
        provider: IntelliServe_Dxtreme.currentUser.MapServiceDescription(),
        width: ko.observable($(window).width()),
        height: ko.observable($(window).height()),
        zoom: 13
    }

    function handleViewShown() {
        loadPanelVisible(true);
        IntelliServe_Dxtreme.db.v_Jobcards_Mobile.byKey(id).done(function (data) {
            markersByCoordinates(data);
            loadPanelVisible(false);
        }).fail(function () {
            loadPanelVisible(false);
        });
    }

    function markersByCoordinates(result) {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function (position) {
                mapMarkers.push({ location: [position.coords.latitude, position.coords.longitude], tooltip: "You are here" });
                mapMarkers.push({ location: [result.Latitude, result.Longitude], title: result.JobCardNumber, tooltip: result.FullAddress });

                mapRoutes.push({ color: "blue", weight: 5, locations: [[position.coords.latitude, position.coords.longitude], [result.Latitude, result.Longitude]] });
            }, mapErrorHandler, { timeout: 60000 });
        } else {
            DevExpress.ui.notify('Geolocation not available', 'error', 3000);
        }
    }

    function mapErrorHandler(error) {
        switch (error.code) {
            case error.PERMISSION_DENIED:
                DevExpress.ui.notify('User denied the request for Geolocation', 'error', 3000);
                break;
            case error.POSITION_UNAVAILABLE:
                DevExpress.ui.notify('Location information is unavailable', 'error', 3000);
                break;
            case error.TIMEOUT:
                DevExpress.ui.notify('The request to get user location timed out', 'error', 3000);
                break;
            case error.UNKNOWN_ERROR:
                DevExpress.ui.notify('An unknown error occurred', 'error', 3000);
                break;
        }
    }

    return {
        viewShown: handleViewShown,
        loadPanelVisible: loadPanelVisible,
        dxMapOptions: dxMapOptions
    };
};