﻿IntelliServe_Dxtreme.JobCardSignature = function (params) {
    "use strict";

    var wrapper,clearButton,saveButton,canvas,signaturePad,id = params.id;

    // Adjust canvas coordinate space taking into account pixel ratio,
    // to make it look crisp on mobile devices.
    // This also causes canvas to be cleared.
    function resizeCanvas() {
        // When zoomed out to less than 100%, for some very strange reason,
        // some browsers report devicePixelRatio as less than 1
        // and only part of the canvas is cleared then.
        var ratio = Math.max(window.devicePixelRatio || 1, 1);
        canvas.width = canvas.offsetWidth * ratio;
        canvas.height = canvas.offsetHeight * ratio;
        canvas.getContext("2d").scale(ratio, ratio);
    }

    function handleSave() {
        if (signaturePad.isEmpty()) {
            DevExpress.ui.dialog.alert("No signature captured", "Signature");
        } else {
            var latitude, longitude;

            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    latitude = position.coords.latitude;
                    longitude = position.coords.longitude;
                });
            }

            IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardSignature(id, signaturePad.toDataURL(), latitude, longitude).done(function () {
                IntelliServe_Dxtreme.app.back();
                DevExpress.ui.notify('Image successfully uploaded', 'success', 3000);
            })
            .fail(function () {
                DevExpress.ui.notify('Failed uploading signature', 'error', 3000);
            });
        }
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    function handleViewShown() {
        wrapper = document.getElementById("signature-pad");
        canvas = wrapper.querySelector("canvas");

        window.onresize = resizeCanvas;
        resizeCanvas();

        signaturePad = new SignaturePad(canvas);
    }

    return {
        viewShown: handleViewShown,
        handleSave: handleSave,
        handleCancel: handleCancel,
    };
};