﻿IntelliServe_Dxtreme.JobCardAttachments = function (params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource, isLoadIndicatorVisible = ko.observable(false);;

    function handleJobCardAttachmentsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if (!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load()
                .fail(function () {
                    shouldReload = true;
                })
                .always(function () {
                    isReady.resolve();
                });
        }
        else if (shouldReload) {
            refreshList();
        }
    }

    function onAttachmentClick(e) {
        isLoadIndicatorVisible(true);

        var fileWritter = new AppUtils.FileWritter(e.FileName());

        fileWritter.saveBase64ToBinary(e.Content(), function (r) {
            AppUtils.viewFile(e.FileName());
            isLoadIndicatorVisible(false);
        }, function (e) {
            DevExpress.ui.notify("File Error", 'Warning', 3000);
            isLoadIndicatorVisible(false);
        });
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.v_JobCardAttachment_Mobile.off("modified", handleJobCardAttachmentsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetJobcardAttachments(id);

    IntelliServe_Dxtreme.db.v_JobCardAttachment_Mobile.on("modified", handleJobCardAttachmentsModification);

    return {
        isLoadIndicatorVisible: isLoadIndicatorVisible,
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot,
        onAttachmentClick: onAttachmentClick
    };
};