﻿IntelliServe_Dxtreme.CheckListAdd = function (params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        searchString = ko.observable(''), selectedItems = ko.observableArray(),
        dataSource;

    function insert() {
        var items = selectedItems();

        for (var i = 0; i < items.length; i++) {
            IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardCheckList(id, items[i]);
        }

        IntelliServe_Dxtreme.app.back();
    }

    function handleSave() {
        insert();
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    function handleChecklistsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if (!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function () {
                isReady.resolve();
            });
        }
        else if (shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.JobCardChecklists.off("modified", handleChecklistsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    ko.computed(function () {
        return searchString();
    }).extend({
        throttle: 500
    }).subscribe(function (value) {
        dataSource.searchValue(value);
        dataSource.load().done();
    });

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetCheckLists();

    IntelliServe_Dxtreme.db.JobCardChecklists.on("modified", handleChecklistsModification);

    return {
        id: id,
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        handleSave: handleSave,
        handleCancel: handleCancel,
        openCreateViewAsRoot: openCreateViewAsRoot,
        searchString: searchString,
        selectedItems: selectedItems,
        find: function () {
            searchString('');
        }
    };
};