IntelliServe_Dxtreme.JobCardChecklistEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isNew = (id === undefined),
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcardchecklist = new IntelliServe_Dxtreme.JobCardChecklistViewModel(),
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.JobCardChecklists.byKey(id, { expand: ["JobCard1", "Checklist1"] }).done(function(data) {
            jobcardchecklist.fromJS(data);
        });
    }

    function update() {
        IntelliServe_Dxtreme.db.JobCardChecklists.update(id, jobcardchecklist.toJS()).done(function() {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function insert() {
        IntelliServe_Dxtreme.db.JobCardChecklists.insert(jobcardchecklist.toJS()).done(function(values, newId) {
            IntelliServe_Dxtreme.app.navigate({ view: "JobCardChecklistDetails", id: newId }, { target: "current" });
        });
    }

    function handleSave() {
        if(isNew)
            insert();
        else
            update();
    }

    function handleCancel() {
        if(!isNew) {
            IntelliServe_Dxtreme.app.back();
        }
        else {
            if(isSplitLayout) {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
            else {
                IntelliServe_Dxtreme.app.back();
            }
        }
    }

    function handleViewShowing() {
        if(!isNew)
            load().done(function() {
                isReady.resolve();
            });
        else {
            jobcardchecklist.clear();
            isReady.resolve();
        }
    }

    return {
        jobcardchecklist: jobcardchecklist,
        jobcardsSource: {
            store: IntelliServe_Dxtreme.db.JobCards,
            map: function(data) {
                return new IntelliServe_Dxtreme.JobCardViewModel(data);
            }
        },
        checklistsSource: {
            store: IntelliServe_Dxtreme.db.Checklists,
            map: function(data) {
                return new IntelliServe_Dxtreme.ChecklistViewModel(data);
            }
        },
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};