IntelliServe_Dxtreme.JobCardChecklist = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleJobCardChecklistsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if(!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function() {
                isReady.resolve();
            });
        }
        else if(shouldReload) {
            refreshList();
        }

        refreshList();
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.JobCardChecklists.off("modified", handleJobCardChecklistsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetJobcardCheckList(id);

    IntelliServe_Dxtreme.db.JobCardChecklists.on("modified", handleJobCardChecklistsModification);

    return {
        id: id,
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot,
        GetColor: function (item) {
            var colorObject = pusher.color('packed_argb', item);
            return colorObject.html('hex6');
        }
    };   
};