IntelliServe_Dxtreme.JobCardChecklistItemDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        jobcardchecklistitem = new IntelliServe_Dxtreme.JobCardChecklistItemViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.JobCardChecklistItems.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("JobCardChecklistItem", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.JobCardChecklistItems.byKey(id, { expand: ["JobCardChecklist1", "CheckListGroup1"] }).done(function(data) {
            jobcardchecklistitem.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        jobcardchecklistitem: jobcardchecklistitem,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};