IntelliServe_Dxtreme.JobCardChecklistItemEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleJobCardChecklistItemsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if (!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function () {
                isReady.resolve();
            });
        }
        else if (shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.v_JobCardChecklistItems_Mobile.off("modified", handleJobCardChecklistItemsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetJobcardCheckListItems(id);

    IntelliServe_Dxtreme.db.v_JobCardChecklistItems_Mobile.on("modified", handleJobCardChecklistItemsModification);

    function update() {
        var array = dataSource.items();
        var JobCardChecklistItem, JobCardChecklistItemID;

        for (var i = 0; i < array.length; i++) {
            var array1 = array[i].items;

            for (var j = 0; j < array1.length; j++) {
                JobCardChecklistItemID = array1[j].Oid();

                JobCardChecklistItem = new IntelliServe_Dxtreme.JobCardChecklistItemViewModel();

                JobCardChecklistItem.Oid(array1[j].Oid());
                JobCardChecklistItem.Value(String(array1[j].Value()));

                IntelliServe_Dxtreme.db.JobCardChecklistItems.update(JobCardChecklistItemID, JobCardChecklistItem.toJS());
            }
        }

        IntelliServe_Dxtreme.app.back();
    }

    function handleSave() {
        update();
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    return {
        id: id,
        isReady: isReady.promise(),
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot,
        handleSave: handleSave,
        handleCancel: handleCancel,
        dataSource: dataSourceObservable
    };
};