IntelliServe_Dxtreme.JobCardChecklistItem = function(params, viewInfo) {
    "use strict";

    var shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleJobCardChecklistItemsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if(!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function() {
                isReady.resolve();
            });
        }
        else if(shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.JobCardChecklistItems.off("modified", handleJobCardChecklistItemsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = new DevExpress.data.DataSource({
        store: IntelliServe_Dxtreme.db.JobCardChecklistItems,
        map: function(item) {
            return new IntelliServe_Dxtreme.JobCardChecklistItemViewModel(item);
        }
    });

    IntelliServe_Dxtreme.db.JobCardChecklistItems.on("modified", handleJobCardChecklistItemsModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot
    };   
};