IntelliServe_Dxtreme.JobCardEquipmentAdd = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcardequipment = new IntelliServe_Dxtreme.JobCardEquipmentViewModel(),
        isReady = $.Deferred(), itemValidationRules;

    function insert() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardEquipment(id, jobcardequipment).done(function () {
            if (isSplitLayout) {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
            else {
                IntelliServe_Dxtreme.app.back();
            }
        });
    }

    function handleSave() {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            insert();
        }
    }

    function handleCancel() {
        if (isSplitLayout) {
            IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
        }
        else {
            IntelliServe_Dxtreme.app.back();
        }
    }

    function handleViewShowing() {
        jobcardequipment.clear();
        isReady.resolve();
    }

    itemValidationRules = {
        validationRules: [{
            type: "required",
            message: "Required"
        }]
    };

    var viewModel = {
        jobcardequipment: jobcardequipment,
        jobcardsSource: {
            store: IntelliServe_Dxtreme.db.JobCards,
            map: function(data) {
                return new IntelliServe_Dxtreme.JobCardViewModel(data);
            }
        },
        equipmentsSource: {
            store: IntelliServe_Dxtreme.db.Equipments,
            map: function(data) {
                return new IntelliServe_Dxtreme.EquipmentViewModel(data);
            }
        },
        faulttypesSource: {
            store: IntelliServe_Dxtreme.db.FaultTypes,
            map: function(data) {
                return new IntelliServe_Dxtreme.FaultTypeViewModel(data);
            }
        },
        itemValidationRules: itemValidationRules,
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};