IntelliServe_Dxtreme.JobCardEquipmentDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        jobcardequipment = new IntelliServe_Dxtreme.JobCardEquipmentViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.JobCardEquipments.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("JobCardEquipment", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.JobCardEquipments.byKey(id, { expand: ["JobCard1", "Equipment1", "FaultType1"] }).done(function(data) {
            jobcardequipment.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        jobcardequipment: jobcardequipment,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};