IntelliServe_Dxtreme.JobCardEquipmentEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcardequipment = new IntelliServe_Dxtreme.JobCardEquipmentViewModel(),
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.JobCardEquipments.byKey(id, { expand: ["JobCard1", "Equipment1", "FaultType1"] }).done(function(data) {
            jobcardequipment.fromJS(data);
        });
    }

    function update() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().UpdateJobCardEquipment(id, jobcardequipment).done(function () {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function handleSave() {
        update();
    }

    function handleCancel() {
        IntelliServe_Dxtreme.app.back();
    }

    function handleViewShowing() {
        load().done(function () {
            isReady.resolve();
        });
    }

    return {
        jobcardequipment: jobcardequipment,
        jobcardsSource: {
            store: IntelliServe_Dxtreme.db.JobCards,
            map: function(data) {
                return new IntelliServe_Dxtreme.JobCardViewModel(data);
            }
        },
        equipmentsSource: {
            store: IntelliServe_Dxtreme.db.Equipments,
            map: function(data) {
                return new IntelliServe_Dxtreme.EquipmentViewModel(data);
            }
        },
        faulttypesSource: {
            store: IntelliServe_Dxtreme.db.FaultTypes,
            map: function(data) {
                return new IntelliServe_Dxtreme.FaultTypeViewModel(data);
            }
        },
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};