IntelliServe_Dxtreme.JobCardItemAdd = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcarditem = new IntelliServe_Dxtreme.JobCardItemViewModel(),
        quantityValidationRules, itemValidationRules,
        isReady = $.Deferred();

    function insert() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardItem(id, jobcarditem.Item1(), jobcarditem.Quantity()).done(function () {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function handleSave() {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            insert();
        }
    }

    function handleCancel() {
        if (isSplitLayout) {
            IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
        }
        else {
            IntelliServe_Dxtreme.app.back();
        }
    }

    function handleViewShowing() {
        jobcarditem.clear();
        isReady.resolve();
    }

    itemValidationRules = {
        validationRules: [{
            type: "required",
            message: "Item is required"
        }]
    };

    quantityValidationRules = {
        validationRules: [[{
            type: "required",
            message: "Quantity is required"
        }], [{ type: 'numeric' }]]
    };

    var viewModel = {
        jobcarditem: jobcarditem,
        itemsSource: IntelliServe_Dxtreme.dbDataLayer.Instance().ItemDetails(),
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise(),
        itemValidationRules: itemValidationRules,
        quantityValidationRules: quantityValidationRules
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};