IntelliServe_Dxtreme.JobCardItemEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcarditem = new IntelliServe_Dxtreme.JobCardItemViewModel(),
        quantityValidationRules, itemValidationRules,
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.JobCardItems.byKey(id, { expand: ["Item1","JobCard1"] }).done(function (data) {
            jobcarditem.fromJS(data);
        });
    }

    function update() {
        //IntelliServe_Dxtreme.dbDataLayer.Instance().UpdateJobCardItem(id, jobcarditem).done(function () {
        IntelliServe_Dxtreme.dbDataLayer.Instance().UpdateJobCardItem(id, jobcarditem, jobcarditem.Item1(), jobcarditem.Quantity()).done(function () {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function handleSave() {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            update();
        }
    }

    function handleCancel() {
        if (isSplitLayout) {
            IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
        }
        else {
            IntelliServe_Dxtreme.app.back();
        }
    }

    function handleViewShowing() {
        //jobcarditem.clear();
        load().done(function () {
            isReady.resolve();
        });
    }

    itemValidationRules = {
        validationRules: [{
            type: "required",
            message: "Item is required"
        }]
    };

    quantityValidationRules = {
        validationRules: [[{
            type: "required",
            message: "Quantity is required"
        }], [{ type: 'numeric' }]]
    };

    var viewModel = {
        jobcarditem: jobcarditem,
        itemsSource: IntelliServe_Dxtreme.dbDataLayer.Instance().ItemDetails(),
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise(),
        itemValidationRules: itemValidationRules,
        quantityValidationRules: quantityValidationRules
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};