IntelliServe_Dxtreme.JobCardItem = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleJobCardItemsModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if(!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function () {
                isReady.resolve();
            });
        }
        else if(shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.JobCardItems.off("modified", handleJobCardItemsModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = IntelliServe_Dxtreme.dbDataLayer.Instance().GetJobcardItems(id);

    IntelliServe_Dxtreme.db.JobCardItems.on("modified", handleJobCardItemsModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot
    };   
};