IntelliServe_Dxtreme.MobileJobCardItemAdd = function (params, viewInfo) {
    "use strict";

    var id = params.id,
        isSplitLayout = viewInfo.layoutController.name === "split",
        mobilejobcarditem = new IntelliServe_Dxtreme.MobileJobCardItemViewModel(),
        quantityValidationRules, itemValidationRules,
        isReady = $.Deferred();

    function insert() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertMobileJobCardItem(id, mobilejobcarditem.Item1(), mobilejobcarditem.Quantity()).done(function () {
            mobilejobcarditem.clear();
        });
    }

    function handleSave() {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            insert();
        }
    }

    function handleCancel() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().UpdateMobileBaseReceived(id);
        IntelliServe_Dxtreme.app.navigate("JobCard", { root: true });
    }

    function handleViewShowing() {
        mobilejobcarditem.clear();
        isReady.resolve();
    }

    itemValidationRules = {
        validationRules: [{
            type: "required",
            message: "Item is required"
        }]
    };

    quantityValidationRules = {
        validationRules: [[{
            type: "required",
            message: "Quantity is required"
        }], [{ type: 'numeric' }]]
    };

    var viewModel = {
        mobilejobcarditem: mobilejobcarditem,
        itemsSource: IntelliServe_Dxtreme.dbDataLayer.Instance().ItemDetails(),
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise(),
        itemValidationRules: itemValidationRules,
        quantityValidationRules: quantityValidationRules
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};