IntelliServe_Dxtreme.JobCardNoteAdd = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        paramsResult,
        isSplitLayout = viewInfo.layoutController.name === "split",
        jobcardnote = new IntelliServe_Dxtreme.JobCardNoteViewModel(),
        descriptionValidationRules,
        handleSave,
        isReady = $.Deferred();

    function insert() {
        IntelliServe_Dxtreme.dbDataLayer.Instance().InsertJobCardNote(id, jobcardnote.Description()).done(function () {
            IntelliServe_Dxtreme.app.back();
        });
    }

    handleSave = function (params) {
        var result = DevExpress.validationEngine.validateModel(this);

        if (result.isValid) {
            insert();
        }
    };

    function handleCancel() {
        if (isSplitLayout) {
            IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
        }
        else {
            IntelliServe_Dxtreme.app.back();
        }
    }

    function handleViewShowing() {
        jobcardnote.clear();
        isReady.resolve();
    }

    descriptionValidationRules = {
        validationRules: [{
            type: "required",
            message: "Description is required"
        }]
    };

    var viewModel = {
        jobcardnote: jobcardnote,
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise(),
        descriptionValidationRules: descriptionValidationRules
    };

    DevExpress.validationEngine.registerModelForValidation(viewModel);

    return viewModel;
};