IntelliServe_Dxtreme.JobCardNoteDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        jobcardnote = new IntelliServe_Dxtreme.JobCardNoteViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.JobCardNotes.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("JobCardNote", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.JobCardNotes.byKey(id, { expand: ["JobCard1"] }).done(function(data) {
            jobcardnote.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        jobcardnote: jobcardnote,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};