IntelliServe_Dxtreme.JobCardNote = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        shouldReload = false,
        openCreateViewAsRoot = viewInfo.layoutController.name === "split",
        isReady = $.Deferred(),
        dataSourceObservable = ko.observable(),
        dataSource;

    function handleJobCardNotesModification() {
        shouldReload = true;
    }

    function handleViewShowing() {
        if(!dataSourceObservable()) {
            dataSourceObservable(dataSource);
            dataSource.load().always(function() {
                isReady.resolve();
            });
        }
        else if(shouldReload) {
            refreshList();
        }
    }

    function handleViewDisposing() {
        IntelliServe_Dxtreme.db.JobCardNotes.off("modified", handleJobCardNotesModification);
    }

    function refreshList() {
        shouldReload = false;
        dataSource.pageIndex(0);
        dataSource.load();
    }

    dataSource = new DevExpress.data.DataSource({
        store: IntelliServe_Dxtreme.db.JobCardNotes,
        filter: params.id ? ['JobCard1.Oid', new DevExpress.data.EdmLiteral("guid'" + params.id + "'")] : [],
        map: function(item) {
            return new IntelliServe_Dxtreme.JobCardNoteViewModel(item);
        }
    });

    IntelliServe_Dxtreme.db.JobCardNotes.on("modified", handleJobCardNotesModification);

    return {
        isReady: isReady.promise(),
        dataSource: dataSourceObservable,
        refreshList: refreshList,
        viewShowing: handleViewShowing,
        viewDisposing: handleViewDisposing,
        openCreateViewAsRoot: openCreateViewAsRoot
    };   
};