IntelliServe_Dxtreme.QuoteDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        quote = new IntelliServe_Dxtreme.QuoteViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.Quotes.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("Quote", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.Quotes.byKey(id, { expand: ["User1", "Client1", "Location1", "Invoice1", "JobCard1", "Ticket1", "JobProject1", "QuoteTerm"] }).done(function(data) {
            quote.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        quote: quote,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};