IntelliServe_Dxtreme.QuoteItemDetails = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        quoteitem = new IntelliServe_Dxtreme.QuoteItemViewModel(),
        isReady = $.Deferred();

    function handleDelete() {
        DevExpress.ui.dialog.confirm("Are you sure you want to delete this item?", "Delete item").then(function(result) {
            if(result)
                handleConfirmDelete();
        });
    }

    function handleConfirmDelete() {        
        IntelliServe_Dxtreme.db.QuoteItems.remove(id).done(function() {
            if(viewInfo.canBack) {
                IntelliServe_Dxtreme.app.navigate("QuoteItem", { target: "back" });
            }
            else {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
        });
    }

    function handleViewShowing() {
        IntelliServe_Dxtreme.db.QuoteItems.byKey(id, { expand: ["Quote1", "Item"] }).done(function(data) {
            quoteitem.fromJS(data);
            isReady.resolve();
        });
    }

    return {
        id: id,
        quoteitem: quoteitem,
        handleDelete: handleDelete,        
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};