IntelliServe_Dxtreme.QuoteItemEdit = function(params, viewInfo) {
    "use strict";

    var id = params.id,
        isNew = (id === undefined),
        isSplitLayout = viewInfo.layoutController.name === "split",
        quoteitem = new IntelliServe_Dxtreme.QuoteItemViewModel(),
        isReady = $.Deferred();

    function load() {
        return IntelliServe_Dxtreme.db.QuoteItems.byKey(id, { expand: ["Quote1", "Item"] }).done(function(data) {
            quoteitem.fromJS(data);
        });
    }

    function update() {
        IntelliServe_Dxtreme.db.QuoteItems.update(id, quoteitem.toJS()).done(function() {
            IntelliServe_Dxtreme.app.back();
        });
    }

    function insert() {
        IntelliServe_Dxtreme.db.QuoteItems.insert(quoteitem.toJS()).done(function(values, newId) {
            IntelliServe_Dxtreme.app.navigate({ view: "QuoteItemDetails", id: newId }, { target: "current" });
        });
    }

    function handleSave() {
        if(isNew)
            insert();
        else
            update();
    }

    function handleCancel() {
        if(!isNew) {
            IntelliServe_Dxtreme.app.back();
        }
        else {
            if(isSplitLayout) {
                IntelliServe_Dxtreme.app.navigate("Blank", { target: "current" });
            }
            else {
                IntelliServe_Dxtreme.app.back();
            }
        }
    }

    function handleViewShowing() {
        quoteitem.clear();
        if(!isNew)
            load().done(function() {
                isReady.resolve();
            });
        else {
            isReady.resolve();
        }
    }

    return {
        quoteitem: quoteitem,
        quotesSource: {
            store: IntelliServe_Dxtreme.db.Quotes,
            map: function(data) {
                return new IntelliServe_Dxtreme.QuoteViewModel(data);
            }
        },
        itemsSource: {
            store: IntelliServe_Dxtreme.db.Items,
            map: function(data) {
                return new IntelliServe_Dxtreme.ItemViewModel(data);
            }
        },
        handleSave: handleSave,
        handleCancel: handleCancel,
        viewShowing: handleViewShowing,
        isReady: isReady.promise()
    };
};